/*
	cd ../<test-3D>; make

	-h - инструкция по применению;
 	-s - формировать 'черный эран' (для стенда-разбраковщик);
 	-ss - формировать '1-й эран шестиренок' (для стенда-разбраковщик) 
 	-e <тип image>  (одно из png|tiff|tga|bmp|jpg|...);

./test3D -s  -b  -e png -t 2 -V 1
./test3D -ss -b -e png -t 2 -V 1

	в PWD	Image-black.jpg		- image 'черноно эрана'
	в PWD	Image-gears.jpg		- image '1-го эрана шестиренок'
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <GL/gl.h>
#include <GL/glx.h>
//#include <Imlib.h>
#include <giblib/gib_imlib.h>

#include <signal.h>
#include <errno.h>


#include <sys/time.h>
#include <unistd.h>

/* return current time (in seconds) */
static int
current_time(void)
{
   struct timeval tv;
   struct timezone tz;
   (void) gettimeofday(&tv, &tz);
   return (int) tv.tv_sec;
}

/* return current time (in miliseconds) */
static int
cur_time_ms(void)
{
   struct timeval tv;
   struct timezone tz;
   (void) gettimeofday(&tv, &tz);
   return (int) 1000*tv.tv_sec +tv.tv_usec/1000;
}

#ifndef M_PI
#define M_PI 3.14159265
#endif


static GLfloat view_rotx = 20.0, view_roty = 30.0, view_rotz = 0.0;
static GLint gear1, gear2, gear3;
static GLfloat angle = 0.0;	/* начальный угол колес */
static GLfloat Da = 1.0;	/* измение угла на каждом кадре */
static int runtime = 20;
static int t_beg;		/* время начала работы программы */
static int t_cur;
static int end_work_prog = 0;	/* признак конца работы */
static int verbose = 0;
static long count = 0L;
static int Z = 0;		/* отмена перехвата <Control>+C&Z */
static int my_pid = 0;
static int without_border = 0;
static int Pause = 0;		/* stop-start изображения */
static int BackSpace = 0;	/* изменить направление вращения */

/*
 * Для сохранения изображения 
 * не крутить 'шестиренки'
 */
int	no_twist_gears = 0;	// no_twist_gears ==1, 'черный эран'
char	*ext_file = NULL;	// расширение имени файла jmage
int	res_prog = 0;		// для режима SAVE_IMAGE & SCREEN_SHOT

	Display*	display;
	Window		window;
	Window		root;
int	Width = 0, Height = 0;	// геометрия Display;
int	screen_num;

typedef struct {
	GLfloat	r;	/* внутренний	радиус */
	GLfloat	R;	/* внешний	радиус */
	GLfloat	w;	/* толщина	колеса */
	GLfloat	t;	/* число	зубьев */
	GLfloat	h;	/* высота	зубьев */
} geom_wheel_t;


#define NVWs 10
geom_wheel_t	VWs[NVWs*3] = {
	/* 0-й вариант - все колеса одинаковые-средние, как это было в СТДП */
	1.0,	2.0,	2.0,	20,	0.7,
	1.0,	2.0,	2.0,	20,	0.7,
	1.0,	2.0,	2.0,	20,	0.7,

	/* 1-й вариант */
	1.5,	2.7,	1.5,	25,	0.7,/* 1-е колесо - большое */
	1.0,	2.0,	2.0,	15,	0.7,/* 2-е колесо - среднее */
	0.7,	1.2,	1.75,	20,	0.7,/* 3-е колесо - маленькое */

	/* 2-й вариант */
	2.4,	3.0,	1.5,	25,	0.5,/* 1-е колесо - большое, тонкое,
						большой вн.радиус */
	1.0,	2.0,	3.0,	15,	0.7,/* 2-е колесо - среднее,
						но широкое */
	0.5,	1.2,	4.8,	20,	0.6,/* 3-е колесо - маленькое,
						но очень широкое */
	/* 3-й вариант - много зубьев */
	0.7,	1.4,	1.75,	20,	0.7,/* 1-е колесо - маленькое */
	1.0,	2.0,	2.0,	15,	0.7,/* 2-е колесо - среднее */
	1.5,	2.5,	1.5,	25,	0.7,/* 3-е колесо - большое */
	99
	};

char *specification_VWs[NVWs] = {
/*0*/	"Все колеса одинаковые-средние, как это было в СТДП.",
/*1*/	"Колеса :1-е - большое, 2-е - среднее, 3-е - маленькое",
/*2*/	"Колеса :\n"
		"\t1-е  - большое и большой вн.радиус, тонкое,\n"
		"\t2-е  - среднее, но широкое,\n"
		"\t3-е  - маленькое, но очень широкое.",
/*3*/	"Много зубьев."
};


geom_wheel_t	Ws[4] = { 	/* колеса, как были в исходной программе */
	0, 0, 0, 0, 0,		/* 0-е колесо не используется */
	1.0,	4.0,	1.0,	20, 0.7,/* 1-е колесо - оч.большое, тонкое */
	0.5,	2.0,	2.0,	10, 0.7,/* 2-е колесо - среднее, широкое */
	1.3,	2.0,	0.5,	10, 0.7 /* 3-е колесо - среднее, узкое */
	};

/* Процедура отработки прерывания работы программы по СONTROL + C */
void
handler_of_signal_SIGINT(int num_sign)
{
	static	int	prev_time_of_signal_SIGINT = 0;
	int	                rval = 0;
	struct	sigaction	act;
	static	struct		sigaction	oact;
	char	            error_msg[64];

	if (end_work_prog)
		return;
	if (prev_time_of_signal_SIGINT == 0) {/* инициализация */
		prev_time_of_signal_SIGINT = 1;
		act.sa_flags = 0;
		act.sa_handler = handler_of_signal_SIGINT;
		(void) sigemptyset(&act.sa_mask);
		rval = sigaction(num_sign, &act, &oact);
		if (rval != 0) {
			strerror_r(errno, error_msg, sizeof(error_msg));
			printf("%d :handler_of_signal_SIGINT() . sigaction(): "
					"%s, errno = %d\n",
					my_pid, error_msg, errno);
		}
		return;
	}
	if (num_sign != SIGINT) {
		printf("Получен сигнал %d (вместо %d)\n", num_sign, SIGINT);
		return;
	}

	/*
	 * Организация останова|выход по 2-му <Control>+C
	 */
	{
	int t = cur_time_ms();
	static int t_cntrl_c =0;

		if (verbose)
			printf("%d :handler_of_signal_SIGINT :получен "
				"сигнал <Control>+C - ", my_pid);
		if ((t_cntrl_c == 0) || (t - t_cntrl_c > 100))
		{ /* останов на 1 сек. */
			if (verbose)
				printf("останов на 1 сек.\n");
			sleep(1);
			t_cntrl_c = cur_time_ms();
			return;
		}
		else { /* 2-й <Control>+C */
			if (verbose)
				printf("выход из программы.\n");
			end_work_prog = 1;
		}
	}
} /* END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ handler_of_signal_SIGINT */

/* Процедура отработки прерывания работы программы по СONTROL + Z */
void
handler_of_signal_SIGTSTP(int num_sign)
{
	static	int	prev_time_of_signal_TSTP = 0;
	int	                rval = 0;
	struct	sigaction	act;
	static	struct		sigaction	oact;
	char	            error_msg[64];

	if (prev_time_of_signal_TSTP == 0) {/* инициализация */
		prev_time_of_signal_TSTP = 1;
		act.sa_flags = 0;
		act.sa_handler = handler_of_signal_SIGTSTP;
		(void) sigemptyset(&act.sa_mask);
		rval = sigaction(num_sign, &act, &oact);
		if (rval != 0) {
			strerror_r(errno, error_msg, sizeof(error_msg));
			printf("handler_of_signal_SIGTSTP() . sigaction(): "
					"%s, errno = %d\n",
					error_msg, errno);
		}
		return;
	}
	if (num_sign != SIGTSTP) {
		printf("Получен сигнал %d (вместо %d)\n", num_sign, SIGTSTP);
		return;
	}

	if (verbose)
		printf("handler_of_signal_SIGTSTP :получен "
				"сигнал <Control>+Z\n");
} /* END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ handler_of_signal_SIGTSTP */

/*
 *
 *  Draw a gear wheel.  You'll probably want to call this function when
 *  building a display list since we do a lot of trig here.
 * 
 *  Input:  inner_radius - radius of hole at center
 *          outer_radius - radius at center of teeth
 *          width - width of gear
 *          teeth - number of teeth
 *          tooth_depth - depth of tooth
 */
static void
gear(GLfloat inner_radius, GLfloat outer_radius, GLfloat width,
     GLint teeth, GLfloat tooth_depth)
{
   GLint i;
   GLfloat r0, r1, r2;
   GLfloat angle, da;
   GLfloat u, v, len;

   r0 = inner_radius;
   r1 = outer_radius - tooth_depth / 2.0;
   r2 = outer_radius + tooth_depth / 2.0;

   da = 2.0 * M_PI / teeth / 4.0;

   glShadeModel(GL_FLAT);

   glNormal3f(0.0, 0.0, 1.0);

   /* draw front face */
   glBegin(GL_QUAD_STRIP);
   for (i = 0; i <= teeth; i++) {
      angle = i * 2.0 * M_PI / teeth;
      glVertex3f(r0 * cos(angle), r0 * sin(angle), width * 0.5);
      glVertex3f(r1 * cos(angle), r1 * sin(angle), width * 0.5);
      if (i < teeth) {
	 glVertex3f(r0 * cos(angle), r0 * sin(angle), width * 0.5);
	 glVertex3f(r1 * cos(angle + 3 * da), r1 * sin(angle + 3 * da),
		    width * 0.5);
      }
   }
   glEnd();

   /* draw front sides of teeth */
   glBegin(GL_QUADS);
   da = 2.0 * M_PI / teeth / 4.0;
   for (i = 0; i < teeth; i++) {
      angle = i * 2.0 * M_PI / teeth;

      glVertex3f(r1 * cos(angle), r1 * sin(angle), width * 0.5);
      glVertex3f(r2 * cos(angle + da), r2 * sin(angle + da), width * 0.5);
      glVertex3f(r2 * cos(angle + 2 * da), r2 * sin(angle + 2 * da),
		 width * 0.5);
      glVertex3f(r1 * cos(angle + 3 * da), r1 * sin(angle + 3 * da),
		 width * 0.5);
   }
   glEnd();

   glNormal3f(0.0, 0.0, -1.0);

   /* draw back face */
   glBegin(GL_QUAD_STRIP);
   for (i = 0; i <= teeth; i++) {
      angle = i * 2.0 * M_PI / teeth;
      glVertex3f(r1 * cos(angle), r1 * sin(angle), -width * 0.5);
      glVertex3f(r0 * cos(angle), r0 * sin(angle), -width * 0.5);
      if (i < teeth) {
	 glVertex3f(r1 * cos(angle + 3 * da), r1 * sin(angle + 3 * da),
		    -width * 0.5);
	 glVertex3f(r0 * cos(angle), r0 * sin(angle), -width * 0.5);
      }
   }
   glEnd();

   /* draw back sides of teeth */
   glBegin(GL_QUADS);
   da = 2.0 * M_PI / teeth / 4.0;
   for (i = 0; i < teeth; i++) {
      angle = i * 2.0 * M_PI / teeth;

      glVertex3f(r1 * cos(angle + 3 * da), r1 * sin(angle + 3 * da),
		 -width * 0.5);
      glVertex3f(r2 * cos(angle + 2 * da), r2 * sin(angle + 2 * da),
		 -width * 0.5);
      glVertex3f(r2 * cos(angle + da), r2 * sin(angle + da), -width * 0.5);
      glVertex3f(r1 * cos(angle), r1 * sin(angle), -width * 0.5);
   }
   glEnd();

   /* draw outward faces of teeth */
   glBegin(GL_QUAD_STRIP);
   for (i = 0; i < teeth; i++) {
      angle = i * 2.0 * M_PI / teeth;

      glVertex3f(r1 * cos(angle), r1 * sin(angle), width * 0.5);
      glVertex3f(r1 * cos(angle), r1 * sin(angle), -width * 0.5);
      u = r2 * cos(angle + da) - r1 * cos(angle);
      v = r2 * sin(angle + da) - r1 * sin(angle);
      len = sqrt(u * u + v * v);
      u /= len;
      v /= len;
      glNormal3f(v, -u, 0.0);
      glVertex3f(r2 * cos(angle + da), r2 * sin(angle + da), width * 0.5);
      glVertex3f(r2 * cos(angle + da), r2 * sin(angle + da), -width * 0.5);
      glNormal3f(cos(angle), sin(angle), 0.0);
      glVertex3f(r2 * cos(angle + 2 * da), r2 * sin(angle + 2 * da),
		 width * 0.5);
      glVertex3f(r2 * cos(angle + 2 * da), r2 * sin(angle + 2 * da),
		 -width * 0.5);
      u = r1 * cos(angle + 3 * da) - r2 * cos(angle + 2 * da);
      v = r1 * sin(angle + 3 * da) - r2 * sin(angle + 2 * da);
      glNormal3f(v, -u, 0.0);
      glVertex3f(r1 * cos(angle + 3 * da), r1 * sin(angle + 3 * da),
		 width * 0.5);
      glVertex3f(r1 * cos(angle + 3 * da), r1 * sin(angle + 3 * da),
		 -width * 0.5);
      glNormal3f(cos(angle), sin(angle), 0.0);
   }

   glVertex3f(r1 * cos(0), r1 * sin(0), width * 0.5);
   glVertex3f(r1 * cos(0), r1 * sin(0), -width * 0.5);

   glEnd();

   glShadeModel(GL_SMOOTH);

   /* draw inside radius cylinder */
   glBegin(GL_QUAD_STRIP);
   for (i = 0; i <= teeth; i++) {
      angle = i * 2.0 * M_PI / teeth;
      glNormal3f(-cos(angle), -sin(angle), 0.0);
      glVertex3f(r0 * cos(angle), r0 * sin(angle), -width * 0.5);
      glVertex3f(r0 * cos(angle), r0 * sin(angle), width * 0.5);
   }
   glEnd();
}


static void
draw(void)
{
	GLfloat x1 =-3.0, y1 =-2.0, x2, y2, x3, y3,
		d =0.1, Da1, Da2, Da3, a1, a2, a3;
	static int inn =0;

	x2 = x1 + Ws[1].R + Ws[2].R +d;
	y2 = y1;
	x3 = x1;
	y3 = y1 + Ws[1].R + Ws[3].R +d;

	Da1 = 0;
	Da2 = 180 -360/(4*Ws[2].t);
	Da3 = -90 +90*(Ws[1].t/Ws[3].t) -360/(4*Ws[3].t);
	if (verbose && inn++ < 1)
		printf("Начальные дельты : 1 =%01.01f 2 =%01.01f, 3 =%01.01f\n"
			"\t\tX:Y 1 =%01.01f:%01.01f,"
			" 2=%01.01f:%01.01f, 3 =%01.01f:%01.01f\n",
			Da1, Da2, Da3, x1, y1, x2, y2, x3, y3);

	a1 = Da1 + angle;
	a2 = Da2 + -Ws[1].t/Ws[2].t * angle;
	a3 = Da3 + -Ws[1].t/Ws[3].t * angle;

   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   glPushMatrix();
   glRotatef(view_rotx, 1.0, 0.0, 0.0);
   glRotatef(view_roty, 0.0, 1.0, 0.0);
   glRotatef(view_rotz, 0.0, 0.0, 1.0);

   glPushMatrix();
   glTranslatef(x1, y1, 0.0);
   glRotatef(a1, 0.0, 0.0, 1.0);
   glCallList(gear1);
   glPopMatrix();

   glPushMatrix();
   glTranslatef(x2, y2, 0.0);
   glRotatef(a2, 0.0, 0.0, 1.0);
   glCallList(gear2);
   glPopMatrix();

   glPushMatrix();
   glTranslatef(x3, y3, 0.0);
   glRotatef(a3, 0.0, 0.0, 1.0);
   glCallList(gear3);
   glPopMatrix();

   glPopMatrix();
}


/* new window size or exposure */
static void
reshape(int width, int height)
{
   GLfloat h = (GLfloat) height / (GLfloat) width;

   glViewport(0, 0, (GLint) width, (GLint) height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glTranslatef(0.0, 0.0, -40.0);
}


static void
init(void)
{
   static GLfloat pos[4] = { 5.0, 5.0, 10.0, 0.0 };
   static GLfloat red[4] = { 0.8, 0.1, 0.0, 1.0 };
   static GLfloat green[4] = { 0.0, 0.8, 0.2, 1.0 };
   static GLfloat blue[4] = { 0.2, 0.2, 1.0, 1.0 };

   glLightfv(GL_LIGHT0, GL_POSITION, pos);
   glEnable(GL_CULL_FACE);
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);
   glEnable(GL_DEPTH_TEST);

   /* make the gears */
   gear1 = glGenLists(1);
   glNewList(gear1, GL_COMPILE);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
	gear(Ws[1].r, Ws[1].R, Ws[1].w, Ws[1].t, Ws[1].h);
   glEndList();

   gear2 = glGenLists(1);
   glNewList(gear2, GL_COMPILE);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, green);
	gear(Ws[2].r, Ws[2].R, Ws[2].w, Ws[2].t, Ws[2].h);
   glEndList();

   gear3 = glGenLists(1);
   glNewList(gear3, GL_COMPILE);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue);
	gear(Ws[3].r, Ws[3].R, Ws[3].w, Ws[3].t, Ws[3].h);
   glEndList();

   glEnable(GL_NORMALIZE);
}


/*
 * Create an RGB, double-buffered window.
 * Return the window and context handles.
 */
static void
make_window(const char *name,
             int x, int y, int width, int height,
             GLXContext *ctxRet)
{
   int attrib[] = { GLX_RGBA,
		    GLX_RED_SIZE, 1,
		    GLX_GREEN_SIZE, 1,
		    GLX_BLUE_SIZE, 1,
		    GLX_DOUBLEBUFFER,
		    GLX_DEPTH_SIZE, 1,
		    None };
   XSetWindowAttributes attr;
   unsigned long mask;
   GLXContext ctx;
   XVisualInfo *visinfo;

   screen_num = DefaultScreen(display);
   root = RootWindow(display, screen_num);

   visinfo = glXChooseVisual(display, screen_num, attrib);
   if (!visinfo) {
      printf("Error: couldn't get an RGB, Double-buffered visual\n");
      exit(1);
   }

   /* window attributes */
   attr.background_pixel = 0;
   attr.border_pixel = 0;
   attr.override_redirect = True;
   attr.colormap = XCreateColormap(display, root, visinfo->visual, AllocNone);
   attr.event_mask = StructureNotifyMask | ExposureMask | KeyPressMask;
   mask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
   if (without_border)
	mask |= CWOverrideRedirect;

   window = XCreateWindow(display, root, x, y, width, height,
		        0, visinfo->depth, InputOutput,
		        visinfo->visual, mask, &attr);

   /* set hints and properties */
   {
      XSizeHints sizehints;
      sizehints.x = x;
      sizehints.y = y;
      sizehints.width  = width;
      sizehints.height = height;
      sizehints.flags = USSize | USPosition;
      XSetNormalHints(display, window, &sizehints);
      XSetStandardProperties(display, window, name, name,
                              None, (char **)NULL, 0, &sizehints);
   }


   ctx = glXCreateContext(display, visinfo, NULL, True);
   if (!ctx) {
      printf("Error: glXCreateContext failed\n");
      exit(1);
   }

   XFree(visinfo);

   *ctxRet = ctx;
}


static void hideCursor()
{
        Cursor          cursor;
        Pixmap          blank;
        XColor          dummy;
        char data[1] = {0};

        blank = XCreateBitmapFromData(display, window, data, 1, 1);
        if( blank == None) return;	// FS_CantCreateBitmap;
        cursor = XCreatePixmapCursor(display, blank, blank, &dummy, &dummy,
        		0, 0);
        XFreePixmap(display, blank);
        XDefineCursor(display, window, cursor);
        return;
}


/*
See /usr/include/Imlib2.h

enum _imlib_load_error
{
   IMLIB_LOAD_ERROR_NONE,
   IMLIB_LOAD_ERROR_FILE_DOES_NOT_EXIST,
   IMLIB_LOAD_ERROR_FILE_IS_DIRECTORY,
   IMLIB_LOAD_ERROR_PERMISSION_DENIED_TO_READ,
   IMLIB_LOAD_ERROR_NO_LOADER_FOR_FILE_FORMAT,
   IMLIB_LOAD_ERROR_PATH_TOO_LONG,
   IMLIB_LOAD_ERROR_PATH_COMPONENT_NON_EXISTANT,
   IMLIB_LOAD_ERROR_PATH_COMPONENT_NOT_DIRECTORY,
   IMLIB_LOAD_ERROR_PATH_POINTS_OUTSIDE_ADDRESS_SPACE,
   IMLIB_LOAD_ERROR_TOO_MANY_SYMBOLIC_LINKS,
   IMLIB_LOAD_ERROR_OUT_OF_MEMORY,
   IMLIB_LOAD_ERROR_OUT_OF_FILE_DESCRIPTORS,
   IMLIB_LOAD_ERROR_PERMISSION_DENIED_TO_WRITE,
   IMLIB_LOAD_ERROR_OUT_OF_DISK_SPACE,
   IMLIB_LOAD_ERROR_UNKNOWN
};
*/

char *err_imlib [] = {
	"success",
	"File Does Not Exist",
	"File Is Directory",
	"Permission Denied To Read",
	"No Loader For File Format",
	"Path Too Long",
	"Path Component Non Existant",
	"Path Component Non Directory",
	"Path points Outside Address space",
	"Too Many Symbolic Links",
	"Out Of Memory",
	"Out Of File Descriptors",
	"Permission Denied To Write",
	"Out Of Disk_space",
	"UNKNOWN"
};


void
init_x_and_imlib() {
	Visual *vis = NULL;
	Screen *scr = NULL;
	Colormap cm;

	verbose && printf("%s :screen_num =%d\n", __func__, screen_num);
	if (screen_num)
		scr = ScreenOfDisplay(display, screen_num);
	else
		scr = ScreenOfDisplay(display, DefaultScreen(display));

	vis = DefaultVisual(display, XScreenNumberOfScreen(scr));
	cm = DefaultColormap(display, XScreenNumberOfScreen(scr));

	imlib_context_set_display(display);
	imlib_context_set_visual(vis);
	imlib_context_set_colormap(cm);
	imlib_context_set_color_modifier(NULL);
	imlib_context_set_operation(IMLIB_OP_COPY);
} /* END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ init_x_and_imlib */


int
mk_screenshot(char *nm) {
#include <giblib/giblib.h>
	char	name[32];
	Imlib_Image image;
	Imlib_Load_Error err;
	int	res = 0;

// !!!	init_x_and_imlib(); из программы scrot - не понадобилось !!!
	image = gib_imlib_create_image_from_drawable(root, 0, 0, 0, Width,
                                         Height, 1);
	if (!image)
		gib_eprintf("%s :No image grabbed", __func__);
	imlib_context_set_image(image);
//!!!	imlib_image_attach_data_value("quality", NULL, 100, NULL);

	sprintf(name, "%s.%s", nm, ext_file);
	gib_imlib_save_image_with_error_return(image, name, &err);
	if (err) {
		printf("!!! ОШИБКА !!! %s :"
			"gib_imlib_save_image_with_error_return(%s), "
			"res =%d\n\t'%s'\n",
			__func__, name, err, err_imlib[err]);
		res = 1;
	}
	else
		printf("Сделан снимок дисплея\tв файл \"%s\"\n", name);
	gib_imlib_free_image_and_decache(image);
	return(res);
} /* END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ mk_screenshot */

int
save_image_to_file(char *nm) {
	Imlib_Image buffer;
	char	name[32], *format;
	Imlib_Load_Error err;
	int	res = 0;

	buffer = imlib_create_image(Width, Height); 
	imlib_context_set_image(buffer);
	imlib_context_set_display(display);
	imlib_context_set_visual(DefaultVisual(display, 0));
	imlib_context_set_drawable(window);
	imlib_copy_drawable_to_image(0, 0, 0, Width, Height, 0, 0, 1);
	imlib_image_set_format(ext_file);
	format = imlib_image_format();
	verbose &&
		printf("%s :imlib_context_set_image =%s, image_format =%s\n",
			__func__, ext_file, format);
	sprintf(name, "%s.%s", nm, format);
	imlib_save_image_with_error_return(name, &err);
	if (err) {
		printf("!!! ОШИБКА !!! %s :"
			"imlib_save_image_with_error_return(%s), "
			"res =%d\n\t'%s'\n",
			__func__, name, err, err_imlib[err]);
		res = 1;
	}
	else
		printf("Образ image записан\tв файл \"%s\"\n", name);
	imlib_free_image();
	return(res);
} /* END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ save_image_to_file */


static void
event_loop()
{
	int t_esc =0;
	int frames = 0;	/* для замера при 'verbose' скорости отображения */
	char *name_file_image = NULL;

   if (no_twist_gears) {
	hideCursor();
	name_file_image = no_twist_gears > 1 ? "Image-gears" : "Image-black";
   }

   while (1) {
	XSync(display, 0);	/* !!! */
      while (XPending(display) > 0) {
         XEvent event;
         XNextEvent(display, &event);
         switch (event.type) {
	 case Expose:
            /* we'll redraw below */
	    break;
	 case ConfigureNotify:
	    reshape(event.xconfigure.width, event.xconfigure.height);
	    break;
         case KeyPress:
            {
               int code;
               code = XLookupKeysym(&event.xkey, 0);
               if (verbose) printf("%s KeyPress :code =%x\n", __func__, code);

		/* XK_Escape, XK_Left, XK_Right, ... See X11/keysymdef.h */

               if (code == XK_Escape) {		// <Esc>
			int t = cur_time_ms();
			if (verbose)
				printf("%s (pid %d) :получен  сигнал <Esc> - ",
					__func__, my_pid);
			if ((t_esc == 0) || (t - t_esc > 100)) {
				/* останов на 2 сек. */
				if (verbose)
					printf("останов на 2 сек.\n");
				sleep(1);
				t_esc = cur_time_ms();
				break;
			}
			else { /* 2-й <Esc> */
				if (verbose)
					printf("2-й <Esc> - "
						    "выход из программы.\n");
				return;
			}
               }
               else if (code == XK_BackSpace) {		// <BackSpace>
                  BackSpace = !BackSpace;
               }
               else if (code == XK_Pause) {		// <Pause>, <hold>
                  Pause = !Pause;
               }
               else if (code == XK_Left) {	// <Move left>, <left arrow>
                  view_roty -= 5.0;
               }
               else if (code == XK_Right) {	// <Move right>, <right arrow>
                  view_roty += 5.0;
               }
               else if (code == XK_Up) {	// <Move up>, <up arrow>
                  view_rotx -= 5.0;
               }
               else if (code == XK_Down) {	// <Move down>, <down arrow>
                  view_rotx += 5.0;
               }
            }
         }
      }

      /* next frame */
      if (!Pause)
      	angle += Da;
      count++;

	/*
	 *    Организуем вращение.
	 * Полный цикл оборота 1-го колеса:	view_roty++; view_rotx--;
	 * затем			  :	view_roty--; view_rotx++;
	 * и т.д.
	 */
	 {
	 static int rotation = 1;
	 static	int n_rev_wheel = 0;
	 	if (!Pause) {
			view_roty += rotation*Da;
			view_rotx -= rotation*Da;
	 	}
		if (((int)angle / 360) != n_rev_wheel) {
			rotation *= -1;
			if (verbose)
				printf("Угол =%01.01f, Вращение =%d\n",
					angle, rotation);
		}
		n_rev_wheel = (int)angle / 360;
	 }

	/*
	 * если 'no_twist_gears' > 1
	 * 	будет начальная картинка
	 *	она остановится когда no_twist_gears станет == 1
	 * если 'no_twist_gears' == 1
	 * 	будет 'черный экран'
	 */

	if ((no_twist_gears > 1)	/* будет только начальная картинка */
			|| !no_twist_gears)
		draw();
	if (!no_twist_gears)	/* штатный режим программы */
		glXSwapBuffers(display, window);
	else if ((count < 2) || (no_twist_gears > 1))
		/* фомирование статической картинки (см.выше) */
		glXSwapBuffers(display, window);
	else if (name_file_image) { // SAVE_IMAGE & SCREEN_SHOT
		char	cmd[128];

		printf("Файл \"%s.%s\" удаляем\n", name_file_image, ext_file);
		sprintf(cmd, "rm -rf %s.%s", name_file_image, ext_file);
		system(cmd);
		if (save_image_to_file(name_file_image) != 0)
			res_prog = 1;
		break;
	}
	else
		usleep(20000);	/* задержка на 20 milisec. */

      /* calc framerate */
      {
         static int t0 = -1, mk_return = 0;
         t_cur = current_time();

         if (t0 < 0)
            t_beg = t0 = t_cur;
	 if ((runtime && (t_cur - t_beg > runtime)) || end_work_prog)
		mk_return = 1;	// что-бы в 'verbose' печатать скорость
			
	 no_twist_gears > 1 && no_twist_gears--;
	 frames++;
         if (((t_cur - t0 >= 5.0) || mk_return) && verbose) {
		GLfloat seconds = t_cur - t0;
		GLfloat fps = frames / seconds;
		printf("%4d :%d frames in %3.1f seconds = %6.3f FPS\n",
			t_cur - t_beg, frames, seconds, fps);
		t0 = t_cur;
		frames = 0;
         }
         if (mk_return)
         	return;
      }
   }
} /* END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ event_loop */

void
prn_Ws() {
	int	i;
	for (i =1; i <4; i++)
		printf("Геометрия колеса N %d :"
			"%01.01f %01.01f %01.01f %d %01.01f\n"
		"\tвнутренний\tрадиус =%01.01f\n"
		"\tвнешний\t\tрадиус =%01.01f\n"
		"\tтолщина\t\tколеса =%01.01f\n"
		"\tчисло\t\tзубьев =%d\n"
		"\tвысота\t\tзубьев =%01.01f\n",
		i, Ws[i].r, Ws[i].R, Ws[i].w, (int)Ws[i].t, Ws[i].h,
		Ws[i].r, Ws[i].R, Ws[i].w, (int)Ws[i].t, Ws[i].h);
}

void
prn_VWs() {
	int	i, j, I;
	
	for (j =0; j <NVWs; j++) {
		I = j*3;
		if (VWs[I].r == 99)
			break;
		printf("Вариант N %d : %s\n", j, specification_VWs[j]);
		for (i =0; i < 3; i++, I++)
			printf("Геометрия Колеса N %d :\n"
			"\tвнутренний\tрадиус =%01.01f\n"
			"\tвнешний\t\tрадиус =%01.01f\n"
			"\tтолщина\t\tколеса =%01.01f\n"
			"\tчисло\t\tзубьев =%01.01f\n"
			"\tвысота\t\tзубьев =%01.01f\n",
			i +1,
			VWs[I].r, VWs[I].R, VWs[I].w, VWs[I].t, VWs[I].h);
	}
}


void
counting_number_of_teeth()
{
	GLfloat wt1 = Ws[1].R/Ws[1].t;
	int	t, to;
	t = Ws[2].R / wt1; to = Ws[2].t; Ws[2].t = t;
	if (verbose && to != t)
		printf("Число зубьев колеса N 2 :%d => %d\n", to, t);
	t = Ws[3].R / wt1; to = Ws[3].t; Ws[3].t = t;
	if (verbose && to != t)
		printf("Число зубьев колеса N 3 :%d => %d\n", to, t);
}

#define SECOND_UNIT 	"to sec."
#define MSECOND_UNIT 	"to msec."
#define MKSECOND_UNIT 	"to mksec."
#define NKSECOND_UNIT 	"to nsec."

const char* matchTimeUnit ( double value, int* k )
{
	int integerPart = (int)value;
	double doublePart  = value - (double)integerPart;
	
	
	*k = 1;
	if ( integerPart ) return SECOND_UNIT;
	
	
	if ( !integerPart ) {
		if ( (doublePart / *k ) >= 0.01 ) return SECOND_UNIT;
	}
	
	*k = 1000;
	if ( !integerPart ) {
		if ( (doublePart / *k ) >= 0.000001 )   return MSECOND_UNIT;
	}
	
	*k = 1000000;
	if ( !integerPart ) {
		if ( (doublePart / *k ) >= 0.000000001  ) return MKSECOND_UNIT;	
	}
	
	*k = 1000000000;
	return NKSECOND_UNIT;
}

int
main(int argc, char **argv)
{
   GLXContext ctx;
   char *dpyName = NULL;
   int N, x =0, y =0;
   GLboolean printInfo = GL_FALSE;

	int	cur_opt;
	int	err_args = 0;
	int	instr = 0;
	extern	char *optarg;
	extern	int optind;

	display = XOpenDisplay(dpyName);

#define	get_arg(N, arg)					\
	optarg = argv[optind++];			\
	if (optind > argc || *optarg == '-') {		\
		optind--; break;			\
	}						\
	arg = atof(optarg); printf("%d :arg =%01.01f\n", N, arg);

	my_pid = getpid();
	while ((cur_opt = getopt(argc, argv, "a:e:sbg:G:w:hit:vV:x:y:Z"))
				!= EOF) {
		switch (cur_opt) {
		case 'a':	/* задания угла вращения колес */
			Da = atof(optarg);
			break;

		/*
		 * расширение имени файла jmage
		 * служит признаком сбросить образ в файл
		 * работает в паре с -s
		 */
		case 'e':
			ext_file = optarg;
			break;
		case 's':	// не крутить 'шестиренки'
			no_twist_gears++;
			without_border = 1;
			break;
		case 'b':	/* работать без рамки окна */
			without_border++;
			break;
		case 'h':
			instr = 1;
			break;
		case 'x': /* начало окна по координате X */
			x = atol(optarg);
			break;
		case 'y': /* начало окна по координате Y */
			y = atol(optarg);
			break;
		case 'w': /* геометрия WxH */ {
			char *optarg_ = optarg;
			for (; *optarg++ != 'x';);
			Width = atol(optarg_);
			Height = atol(optarg);
			break;
		}
		case 'i': /* printInfo */
			printInfo = GL_TRUE;
			break;
		case 'g':
			/* геометрия зубчатых колес (все 3 одинаковые)
				<внутренний	радиус>
				<внешний	радиус>
				<толщина	колеса>
				<число		зубьев>
				<высота		зубьев>
			*/
			optind--;
			get_arg(1, Ws[1].r)
			get_arg(1, Ws[1].R)
			get_arg(1, Ws[1].w)
			get_arg(1, Ws[1].t)
			get_arg(1, Ws[1].h)
			Ws[2] = Ws[1];
			Ws[3] = Ws[1];
			break;
		case 'G': {
			geom_wheel_t *W;
			/* геометрия зубчатого колеса
				N - 1|2|3
				<внутренний	радиус>
				<внешний	радиус>
				<толщина	колеса>
				<число		зубьев>
				<высота		зубьев>
			*/
			N = atol(optarg);
			if (!(N > 0 && N < 4)) {
				printf("!!! Ошибка в геометрии"
					" зубчатого колеса :-G =%d !!!\n", N);
				instr = 1;
				err_args = 1;
				break;
			}
			W = &Ws[N];
			get_arg(1, W->r)
			get_arg(1, W->R)
			get_arg(1, W->w)
			get_arg(1, W->t)
			get_arg(1, W->h)
			break;
		}

		case 't': /* время работы программы */
			runtime = atol(optarg);
			break;
		case 'V': /* вариант колес (из таблицы VWs) */
		{int	variant = atol(optarg),j;
			if (variant >= 99) {
				prn_VWs();
				exit (0);
			}
			else {
				for (j =0; j <NVWs; j++)
					if (VWs[j*3].r == 99)
						break;
				if (variant >= j) {
					printf("Задано :-V %d\n"
						"Число реализованных "
						"вариантов =%d\n", variant, j);
					prn_VWs();
					exit (0);
				}
				Ws[1] = VWs[variant*3];
				Ws[2] = VWs[variant*3 +1];
				Ws[3] = VWs[variant*3 +2];
			}
			break;
		}
		case 'v': /* verbose */
			verbose = 1;
			break;
		case 'Z':	/* отмена перехвата <Control>+C&Z */
			Z = 1;
			break;
		default:
			instr = 1;
			err_args = 1;
			break;
		}
	}

	if (instr == 1) {
	    printf("\nИНСТРУКЦИЯ по запуску ПРОГР. %s\n\n"
		"\t-h[v] - печать данной инструкции[+доп.инф.];\n"
		"\t-s  - формировать 'черный эран'\n"\
				"\t\t(для стенда-разбраковщик);\n"
		"\t-ss - формировать '1-й эран шестиренок'\n"\
				"\t\t(для стенда-разбраковщик);\n"
		"\t-e <расширение имени файла image> - "
						"признак сброса image в файл\n"
			"\t\t(одно из png|tiff|tga|bmp|jpg|...);\n"
		"\t-a - задания угла вращения колес\n"
			"\t\t(по умолчанию =%01.01f);\n"
		"\t-b - отображать без рамки окна;\n"
		"\t-i - printInfo;\n"
		"\t-x - начало окна по координате X;\n"
		"\t-y - начало окна по координате Y;\n"
		"\t-w - геометрия экрана - <ширина>x<высота>, "
					"если не задана - на весь экран;\n"
		"\t-t - время работы программы в сек "
				"(по умолчанию =%d);\n"
		"\t-V - вариант колес (из таблицы VWs)\n"
			"\t\t(если N 99 - печать таблицы VWs);\n"
		"\t-v - verbose;\n"
		"\t-Z - отмена перехвата <Control>+C&Z;\n"
		"\n\t-g <геометрия колеса>\n"
		"\t\t- задание геометрии зубчатых колес\n"
		"\t\t\t\t(все 3 одинаковые);\n"
		"\t\t,где <геометрия колеса> :\n"
		"\t\t\t	<внутренний	радиус>,\n"
		"\t\t\t	<внешний	радиус>,\n"
		"\t\t\t	<толщина	колеса>,\n"
		"\t\t\t	<число		зубьев>,\n"
		"\t\t\t	<высота		зубьев>\n"
		"\t-G <N_колеса> <геометрия колеса>\n"
		"\t\t- задание геометрии зубчатого колеса N_колеса\n"
		"\t\t\t\tN_колеса =1|2|3;\n"
		"\tПримечание : \n"
		"\t\tЧисло зубьев у колес N 2 и 3 подгоняется "
							"под колесо N 1;\n"
		"\t\tОстанов отображения по <Esc>,\n"
		"\t\t<Esc> дважды - принудительный выход из прогр.\n"
		"\t\t<Pause>|<hold> - stop,start\n\n",
		argv[0], Da, runtime);
	    if (verbose)
		printf("Управление движением отображения (5 гр.):\n\n"
			"вращение по X\n"
			"\t<Move left>|<left arrow>	- налево\n"
			"\t<Move right>|<right arrow>	- направо\n"
			"вращение по Y\n"
			"\t<Move up>|<up arrow>    	- вверх\n"
			"\t<Move down>|<down arrow>	- вниз\n"
			"\n");

		if (err_args)
			return (-1);
		return (0);
	}
	counting_number_of_teeth();
	if (verbose)
		prn_Ws();

   
   if (no_twist_gears)
   	printf("\n#### Test 3D Graphics, Save Image: mode ='%s' ####\n",
   	    no_twist_gears == 1 ? "black screen" : "gears");
   else
   	printf("\n#### Test 3D Graphics... ####\n");

   if (!display) {
	printf("%s:%d: failed. Can\'t open display %s\n",
		__func__, __LINE__, dpyName);
      return -1;
   }
 
   screen_num = DefaultScreen(display);
   if (Width *Height == 0) {
   	Width = DisplayWidth(display, screen_num);
   	Height = DisplayHeight(display, screen_num);
   }
   
   if (verbose)
   	printf("runtime =%d sec., Width =%d, Height =%d, Da =%01.01f\n",
   		runtime, Width, Height, Da);
   make_window("glxgears", x, y, Width, Height, &ctx);
   XMoveResizeWindow(display, window, x, y, Width, Height);
   XMapWindow(display, window);
   glXMakeCurrent(display, window, ctx);
   reshape(Width, Height);

   if (printInfo) {
      printf("GL_RENDERER   = %s\n", (char *) glGetString(GL_RENDERER));
      printf("GL_VERSION    = %s\n", (char *) glGetString(GL_VERSION));
      printf("GL_VENDOR     = %s\n", (char *) glGetString(GL_VENDOR));
      printf("GL_EXTENSIONS = %s\n", (char *) glGetString(GL_EXTENSIONS));
   }

   init();
   if (!Z) {
	/*	Установка реакции на сигнал SIGINT(<Control>+C) */
	handler_of_signal_SIGINT(SIGINT);
	/*	Перехват сигнала <Control>+Z */
	handler_of_signal_SIGTSTP(SIGTSTP);
   }
   event_loop();

   if (!no_twist_gears || verbose) { 
   	int k = 0;
  	const char* nameunit =
  		matchTimeUnit ( (double)count/(t_cur - t_beg), &k ); 
	
   	printf("%d\t%d sec. :Show 3d objects %s...............%01.01f\n",
   		my_pid, (t_cur - t_beg), nameunit,
   		((double)count/(t_cur - t_beg))*k );
   }

   glXDestroyContext(display, ctx);
   XDestroyWindow(display, window);
   XCloseDisplay(display);

   return (res_prog);
}

